/* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" { target { ! ilp32 } } } } */

#include "test_sme2_acle.h"

/*
** stnt1_f16_base:
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0\]
**	ret
*/
TEST_STORE_COUNT (stnt1_f16_base, svfloat16x2_t, float16_t,
		  svstnt1_f16_x2 (pn8, x0, z0),
		  svstnt1 (pn8, x0, z0))

/*
** stnt1_f16_index:
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0, x1, lsl #?1\]
**	ret
*/
TEST_STORE_COUNT (stnt1_f16_index, svfloat16x2_t, float16_t,
		  svstnt1_f16_x2 (pn8, x0 + x1, z0),
		  svstnt1 (pn8, x0 + x1, z0))

/* Moving the constant into a register would also be OK.  */
/*
** stnt1_f16_1:
**	incb	x0
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0\]
**	ret
*/
TEST_STORE_COUNT (stnt1_f16_1, svfloat16x2_t, float16_t,
		  svstnt1_f16_x2 (pn8, x0 + svcnth (), z0),
		  svstnt1 (pn8, x0 + svcnth (), z0))

/*
** stnt1_f16_2:
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0, #2, mul vl\]
**	ret
*/
TEST_STORE_COUNT (stnt1_f16_2, svfloat16x2_t, float16_t,
		  svstnt1_f16_x2 (pn8, x0 + svcnth () * 2, z0),
		  svstnt1 (pn8, x0 + svcnth () * 2, z0))

/*
** stnt1_f16_14:
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0, #14, mul vl\]
**	ret
*/
TEST_STORE_COUNT (stnt1_f16_14, svfloat16x2_t, float16_t,
		  svstnt1_f16_x2 (pn8, x0 + svcnth () * 14, z0),
		  svstnt1 (pn8, x0 + svcnth () * 14, z0))

/* Moving the constant into a register would also be OK.  */
/*
** stnt1_f16_16:
**	incb	x0, all, mul #16
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0\]
**	ret
*/
TEST_STORE_COUNT (stnt1_f16_16, svfloat16x2_t, float16_t,
		  svstnt1_f16_x2 (pn8, x0 + svcnth () * 16, z0),
		  svstnt1 (pn8, x0 + svcnth () * 16, z0))

/* Moving the constant into a register would also be OK.  */
/*
** stnt1_f16_m1:
**	decb	x0
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0\]
**	ret
*/
TEST_STORE_COUNT (stnt1_f16_m1, svfloat16x2_t, float16_t,
		  svstnt1_f16_x2 (pn8, x0 - svcnth (), z0),
		  svstnt1 (pn8, x0 - svcnth (), z0))

/*
** stnt1_f16_m2:
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0, #-2, mul vl\]
**	ret
*/
TEST_STORE_COUNT (stnt1_f16_m2, svfloat16x2_t, float16_t,
		  svstnt1_f16_x2 (pn8, x0 - svcnth () * 2, z0),
		  svstnt1 (pn8, x0 - svcnth () * 2, z0))

/*
** stnt1_f16_m16:
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0, #-16, mul vl\]
**	ret
*/
TEST_STORE_COUNT (stnt1_f16_m16, svfloat16x2_t, float16_t,
		  svstnt1_f16_x2 (pn8, x0 - svcnth () * 16, z0),
		  svstnt1 (pn8, x0 - svcnth () * 16, z0))

/*
** stnt1_f16_m18:
**	addvl	(x[0-9]+), x0, #-18
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[\1\]
**	ret
*/
TEST_STORE_COUNT (stnt1_f16_m18, svfloat16x2_t, float16_t,
		  svstnt1_f16_x2 (pn8, x0 - svcnth () * 18, z0),
		  svstnt1 (pn8, x0 - svcnth () * 18, z0))

/*
** stnt1_f16_z17:
**	mov	[^\n]+
**	mov	[^\n]+
**	stnt1h	{z[^\n]+}, pn8, \[x0\]
**	ret
*/
TEST_STORE_COUNT (stnt1_f16_z17, svfloat16x2_t, float16_t,
		  svstnt1_f16_x2 (pn8, x0, z17),
		  svstnt1 (pn8, x0, z17))

/*
** stnt1_f16_z22:
**	stnt1h	{z22\.h(?: - |, )z23\.h}, pn8, \[x0\]
**	ret
*/
TEST_STORE_COUNT (stnt1_f16_z22, svfloat16x2_t, float16_t,
		  svstnt1_f16_x2 (pn8, x0, z22),
		  svstnt1 (pn8, x0, z22))

/*
** stnt1_f16_z28:
**	stnt1h	{z28\.h(?: - |, )z29\.h}, pn8, \[x0\]
**	ret
*/
TEST_STORE_COUNT (stnt1_f16_z28, svfloat16x2_t, float16_t,
		  svstnt1_f16_x2 (pn8, x0, z28),
		  svstnt1 (pn8, x0, z28))

/*
** stnt1_f16_pn0:
**	mov	p([89]|1[0-5])\.b, p0\.b
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn\1, \[x0\]
**	ret
*/
TEST_STORE_COUNT (stnt1_f16_pn0, svfloat16x2_t, float16_t,
		  svstnt1_f16_x2 (pn0, x0, z0),
		  svstnt1 (pn0, x0, z0))

/*
** stnt1_f16_pn7:
**	mov	p([89]|1[0-5])\.b, p7\.b
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn\1, \[x0\]
**	ret
*/
TEST_STORE_COUNT (stnt1_f16_pn7, svfloat16x2_t, float16_t,
		  svstnt1_f16_x2 (pn7, x0, z0),
		  svstnt1 (pn7, x0, z0))

/*
** stnt1_f16_pn15:
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn15, \[x0\]
**	ret
*/
TEST_STORE_COUNT (stnt1_f16_pn15, svfloat16x2_t, float16_t,
		  svstnt1_f16_x2 (pn15, x0, z0),
		  svstnt1 (pn15, x0, z0))

/*
** stnt1_vnum_f16_0:
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0\]
**	ret
*/
TEST_STORE_COUNT (stnt1_vnum_f16_0, svfloat16x2_t, float16_t,
		  svstnt1_vnum_f16_x2 (pn8, x0, 0, z0),
		  svstnt1_vnum (pn8, x0, 0, z0))

/* Moving the constant into a register would also be OK.  */
/*
** stnt1_vnum_f16_1:
**	incb	x0
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0\]
**	ret
*/
TEST_STORE_COUNT (stnt1_vnum_f16_1, svfloat16x2_t, float16_t,
		  svstnt1_vnum_f16_x2 (pn8, x0, 1, z0),
		  svstnt1_vnum (pn8, x0, 1, z0))

/*
** stnt1_vnum_f16_2:
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0, #2, mul vl\]
**	ret
*/
TEST_STORE_COUNT (stnt1_vnum_f16_2, svfloat16x2_t, float16_t,
		  svstnt1_vnum_f16_x2 (pn8, x0, 2, z0),
		  svstnt1_vnum (pn8, x0, 2, z0))

/*
** stnt1_vnum_f16_14:
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0, #14, mul vl\]
**	ret
*/
TEST_STORE_COUNT (stnt1_vnum_f16_14, svfloat16x2_t, float16_t,
		  svstnt1_vnum_f16_x2 (pn8, x0, 14, z0),
		  svstnt1_vnum (pn8, x0, 14, z0))

/* Moving the constant into a register would also be OK.  */
/*
** stnt1_vnum_f16_16:
**	incb	x0, all, mul #16
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0\]
**	ret
*/
TEST_STORE_COUNT (stnt1_vnum_f16_16, svfloat16x2_t, float16_t,
		  svstnt1_vnum_f16_x2 (pn8, x0, 16, z0),
		  svstnt1_vnum (pn8, x0, 16, z0))

/* Moving the constant into a register would also be OK.  */
/*
** stnt1_vnum_f16_m1:
**	decb	x0
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0\]
**	ret
*/
TEST_STORE_COUNT (stnt1_vnum_f16_m1, svfloat16x2_t, float16_t,
		  svstnt1_vnum_f16_x2 (pn8, x0, -1, z0),
		  svstnt1_vnum (pn8, x0, -1, z0))

/*
** stnt1_vnum_f16_m2:
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0, #-2, mul vl\]
**	ret
*/
TEST_STORE_COUNT (stnt1_vnum_f16_m2, svfloat16x2_t, float16_t,
		  svstnt1_vnum_f16_x2 (pn8, x0, -2, z0),
		  svstnt1_vnum (pn8, x0, -2, z0))

/*
** stnt1_vnum_f16_m16:
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0, #-16, mul vl\]
**	ret
*/
TEST_STORE_COUNT (stnt1_vnum_f16_m16, svfloat16x2_t, float16_t,
		  svstnt1_vnum_f16_x2 (pn8, x0, -16, z0),
		  svstnt1_vnum (pn8, x0, -16, z0))

/*
** stnt1_vnum_f16_m18:
**	addvl	(x[0-9]+), x0, #-18
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[\1\]
**	ret
*/
TEST_STORE_COUNT (stnt1_vnum_f16_m18, svfloat16x2_t, float16_t,
		  svstnt1_vnum_f16_x2 (pn8, x0, -18, z0),
		  svstnt1_vnum (pn8, x0, -18, z0))

/*
** stnt1_vnum_f16_x1:
**	cntb	(x[0-9]+)
** (
**	madd	(x[0-9]+), (?:x1, \1|\1, x1), x0
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[\2\]
** |
**	mul	(x[0-9]+), (?:x1, \1|\1, x1)
**	stnt1h	{z0\.h(?: - |, )z1\.h}, pn8, \[x0, \3\]
** )
**	ret
*/
TEST_STORE_COUNT (stnt1_vnum_f16_x1, svfloat16x2_t, float16_t,
		  svstnt1_vnum_f16_x2 (pn8, x0, x1, z0),
		  svstnt1_vnum (pn8, x0, x1, z0))
